namespace Flibs {
    public class Branch {
        public const int TARGET_COUNT = 2;

        private int _stateIndex;
        private int _output;

        public Branch(int stateIndex, int output) {
            _stateIndex = stateIndex;
            _output = output;
        }

        public Branch Clone() {
            return new Branch(_stateIndex, _output);
        }

        public int StateIndex {
            get { return _stateIndex; }
        }

        public int Output {
            get { return _output; }
        }
    }
}