namespace Flibs {
    public class SimpleSignalSource : ISignalSource {
        private int _state;
        private int[] _mask;

        public void DoStep() {
            _state++;
        }

        public SimpleSignalSource(int[] mask) {
            Nulling();
            _mask = mask;
        }

        public int Input {
            get { return _mask[_state%_mask.Length]; }
        }

        public int InputNext {
            get { return _mask[(_state + 1)%_mask.Length]; }
        }

        public void Nulling() {
            _state = -1;
        }
    }
}