using System;
using System.Collections;

namespace Flibs {
    public class SimpleGenerationCreator : IGenerationCreator {
        public IList CreateGenearation(Random random, IList generation, IChildCreator childCreator) {
            Flib firstParent = childCreator.GetBestFlib(generation);
            Flib secondParent = (Flib) generation[random.Next(generation.Count)];

            generation[childCreator.GetWorstFlibIndex(generation)] = childCreator.CreateChild(firstParent, secondParent);

            return generation;
        }
    }
}