namespace Flibs {
    public class State {
        private Branch[] _branches;

        public State() {
            _branches = new Branch[Branch.TARGET_COUNT];
        }

        public State Clone() {
            State state = new State();
            state._branches = new Branch[_branches.Length];

            for (int i = 0; i < _branches.Length; i++) {
                state._branches[i] = _branches[i].Clone();
            }

            return state;
        }

        public Branch[] Branches {
            get { return _branches; }
        }
    }
}